## genht 1.0.1

=== Makefile ===
all:
	cd src && make all

install:
	cd src && make install

=== src/Makefile ===
# use -Dinline if compiling with c89
INCDIR=$(install_root)$(DESTDIR)/usr/include/genht
LIBDIR=$(install_root)$(DESTDIR)/usr/lib

VER_MAJOR=1
VER_MINOR=0
VER_PATCH=1
VER=$(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)

CFLAGS=-g $(GENHT_CFLAGS)
LDFLAGS=$(GENHT_LDFLAGS)

BIN=mainsi
OBJS=htss.o htsp.o htsi.o htip.o htpp.o htpi.o hash.o siphash24.o
LIBSO=libgenht.so.$(VER)
LIBSO1=libgenht.so.$(VER_MAJOR)
LIBA=libgenht.a

all: $(BIN) $(OBJS) $(LIBA) $(LIBSO)

clean:
	-rm $(BIN) $(OBJS) $(LIBA) $(LIBSO) genht_std.so genht_std.a

.SUFFIXES:
.SUFFIXES: .o .c

.c.o:
	$(CC) -o $@ -c -fPIC $< $(CFLAGS)

mainsi: mainsi.o htsi.o
	$(CC) -o $@ mainsi.o htsi.o $(LDFLAGS)

$(LIBSO): $(OBJS)
	$(CC) $(LDFLAGS) -shared -dynamic -rdynamic -o $@ $(OBJS)

$(LIBA): $(OBJS)
	ar rvu $@ $(OBJS)

# for compatibility
genht_std.so: $(LIBSO)
	ln -s $(LIBSO) genht_std.so

# for compatibility
genht_std.a: $(LIBA)
	ln -s $(LIBA) genht_std.a

install_:
	mkdir -p $(INCDIR) $(LIBDIR)
	$(CP) `pwd`/hash.h $(INCDIR)/hash.h
	$(CP) `pwd`/ht.h $(INCDIR)/ht.h
	$(CP) `pwd`/ht_inlines.h $(INCDIR)/ht_inlines.h
	$(CP) `pwd`/htip.h $(INCDIR)/htip.h
	$(CP) `pwd`/htsi.h $(INCDIR)/htsi.h
	$(CP) `pwd`/htsp.h $(INCDIR)/htsp.h
	$(CP) `pwd`/htss.h $(INCDIR)/htss.h
	$(CP) `pwd`/htpp.h $(INCDIR)/htpp.h
	$(CP) `pwd`/$(LIBSO) $(LIBDIR)/$(LIBSO)
	$(CP) `pwd`/$(LIBA) $(LIBDIR)/$(LIBA)

uninstall:
	rm -rf $(INCDIR)
	rm $(LIBDIR)/$(LIBSO) $(LIBDIR)/$(LIBA) $(LIBDIR)/$(LIBSO1)

install:
	make install_ CP="cp"
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)

linstall:
	make install_ CP="ln -s"
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)

=== debian/changelog ===
genht (1.0.1-1) unstable; urgency=low

  * Initial packaging

 -- Tibor Palinkas <genht@igor2.repo.hu>  Wed, 14 Jun 2017 20:24:51 +0200

=== debian/control ===
Source: genht
Section: libs
Priority: optional
Maintainer: Tibor Palinkas <genht@igor2.repo.hu>
Uploaders: Bdale Garbee <bdale@gag.com>
Standards-Version: 4.0.0
Homepage: http://repo.hu/projects/genht
Build-Depends: debhelper (>= 9)

Package: libgenht1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Generic hash table lib for C
 Provides a simple interface for creating hash tables with arbitrary
 key and value types. Ships with shared objects for standard table types.

Package: libgenht1-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: Generic hash table lib for C
 Provides a simple interface for creating hash tables with arbitrary
 key and value types. Ships with shared objects for standard table types.
 .
 This package contains the static library and header files used in
 development.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILD_FLAGS = 1
include /usr/share/dpkg/buildflags.mk

export GENHT_LDFLAGS=-Wl,-soname,libgenht.so.1

%:
	dh $@ --parallel

# there's no configuration step at all
override_dh_auto_configure:

override_dh_auto_install:
	dh_auto_install -v --destdir=debian/tmp

## genht 1.1.2

=== Makefile ===
all:
	cd src && make all

install:
	cd src && make install

test:
	cd src && make test

=== doc/Makefile ===
CFLAGS = -I../src

all: example examplev

# you can use -lgenht instead of the ../src/ stuff when it's installed
example: example.o ../src/htsi.o ../src/hash.o
	$(CC) -o example $(LDFLAGS) example.o ../src/htsi.o ../src/hash.o

example.o: example.c
	$(CC) -o example.o -c $(CFLAGS) example.c


examplev: examplev.o
	$(CC) -o examplev $(LDFLAGS) -lm examplev.o

examplev.o: examplev.c
	$(CC) -o examplev.o -c $(CFLAGS) examplev.c

clean:
	-rm example.o example examplev.o examplev

=== debian/changelog ===
genht (1.1.2-1) unstable; urgency=low

  * new upstream version, taking over from Tibor who never finished DM process

 -- Bdale Garbee <bdale@gag.com>  Sat, 08 Jan 2022 11:37:27 -0700

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: genht
 Section: libs
 Priority: optional
-Maintainer: Tibor Palinkas <genht@igor2.repo.hu>
-Uploaders: Bdale Garbee <bdale@gag.com>
-Standards-Version: 4.0.0
+Maintainer: Bdale Garbee <bdale@gag.com>
+Standards-Version: 4.6.0
 Homepage: http://repo.hu/projects/genht
-Build-Depends: debhelper (>= 9)
+Build-Depends: debhelper (>= 13)
 
 Package: libgenht1
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export GENHT_LDFLAGS=-Wl,-soname,libgenht.so.1
 
 %:
-	dh $@ --parallel
+	dh $@
 
 # there's no configuration step at all
 override_dh_auto_configure:

## genht 1.1.3

=== Makefile ===
all:
	cd src && $(MAKE) all

install:
	cd src && $(MAKE) install

test:
	cd src && $(MAKE) test

=== src/Makefile ===
# use -DGENHT_WANT_INLINE to turn half of the API into static inline functions
PREFIX=/usr
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/genht
LIBDIR=$(install_root)$(DESTDIR)$(PREFIX)/lib

HOSTCC = $(CC)

VER_MAJOR=1
VER_MINOR=1
VER_PATCH=3
VER=$(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)

CFLAGS=-g $(GENHT_CFLAGS)
LDFLAGS=$(GENHT_LDFLAGS)

BIN=mainsi
OBJS=htss.o htsp.o htsi.o htip.o htpp.o htpi.o hash.o siphash24.o
LIBSO0=libgenht.so
LIBSO=libgenht.so.$(VER)
LIBSO1=libgenht.so.$(VER_MAJOR)
LIBA=libgenht.a

all: version.h $(BIN) $(OBJS) $(LIBA) $(LIBSO)

clean:
	-rm $(BIN) $(OBJS) $(LIBA) $(LIBSO) genht_std.so genht_std.a version.h ver_edit

.SUFFIXES:
.SUFFIXES: .o .c

.c.o:
	$(CC) -o $@ -c -fPIC $< $(CFLAGS)

mainsi: mainsi.o htsi.o
	$(CC) -o $@ mainsi.o htsi.o $(LDFLAGS)

$(LIBSO): $(OBJS)
	$(CC) $(LDFLAGS) -shared -dynamic -rdynamic -o $@ $(OBJS)

$(LIBA): $(OBJS)
	ar rvu $@ $(OBJS)
	-ar s $@
	-ranlib $@

# for compatibility
genht_std.so: $(LIBSO)
	ln -s $(LIBSO) genht_std.so

# for compatibility
genht_std.a: $(LIBA)
	ln -s $(LIBA) genht_std.a

version.h: version.h.in ver_edit
	./ver_edit $(VER_MAJOR) $(VER_MINOR) $(VER_PATCH) < version.h.in > version.h

ver_edit: ver_edit.c
	$(HOSTCC) -o $@ $(CFLAGS) ver_edit.c

install_:
	mkdir -p $(INCDIR) $(LIBDIR)
	$(CP) `pwd`/hash.h $(INCDIR)/hash.h
	$(CP) `pwd`/siphash24.h $(INCDIR)/siphash24.h
	$(CP) `pwd`/ht.h $(INCDIR)/ht.h
	$(CP) `pwd`/ht.c $(INCDIR)/ht.c
	$(CP) `pwd`/version.h $(INCDIR)/version.h
	$(CP) `pwd`/ht_inlines.h $(INCDIR)/ht_inlines.h
	$(CP) `pwd`/ht_utils.h $(INCDIR)/ht_utils.h
	$(CP) `pwd`/htip.h $(INCDIR)/htip.h
	$(CP) `pwd`/htpi.h $(INCDIR)/htpi.h
	$(CP) `pwd`/htsi.h $(INCDIR)/htsi.h
	$(CP) `pwd`/htsp.h $(INCDIR)/htsp.h
	$(CP) `pwd`/htss.h $(INCDIR)/htss.h
	$(CP) `pwd`/htpp.h $(INCDIR)/htpp.h
	$(CP) `pwd`/$(LIBSO) $(LIBDIR)/$(LIBSO)
	$(CP) `pwd`/$(LIBA) $(LIBDIR)/$(LIBA)

uninstall:
	rm -rf $(INCDIR)
	rm $(LIBDIR)/$(LIBSO) $(LIBDIR)/$(LIBA) $(LIBDIR)/$(LIBSO1) $(LIBDIR)/$(LIBSO0)

install:
	$(MAKE) install_ CP="cp"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)
	-ln -s $(LIBSO) $(LIBDIR)/$(LIBSO0)

linstall:
	$(MAKE) install_ CP="ln -s"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)
	-ln -s $(LIBSO) $(LIBDIR)/$(LIBSO0)

test: mainsi
	@./mainsi > mainsi.out
	@diff mainsi.ref mainsi.out
	@echo "*** QC pass ***"

=== debian/changelog ===
genht (1.1.3-3build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 20 Jan 2026 20:34:09 +0000

genht (1.1.3-3) unstable; urgency=high

  * re-upload to correct unintended use of urgency=low

 -- Bdale Garbee <bdale@gag.com>  Mon, 19 Aug 2024 04:12:41 -0600

genht (1.1.3-2) unstable; urgency=low

  * patch for incompatible pointer types, closes: #1074987

 -- Bdale Garbee <bdale@gag.com>  Thu, 15 Aug 2024 11:15:19 -0600

genht (1.1.3-1) unstable; urgency=low

  * new upstream version, closes: #1066414
  * move .so symlink to -dev package

 -- Bdale Garbee <bdale@gag.com>  Wed, 13 Mar 2024 16:40:22 -0600

genht (1.1.2-2) unstable; urgency=low

  * add a clean target to the top-level Makefile, add more to src/Makefile clean
    target to enable build after build, closes: #1044287

 -- Bdale Garbee <bdale@gag.com>  Wed, 28 Feb 2024 22:48:23 -0700
